import csv
import sys

from scapy.utils import PcapWriter
from scapy.all import *

import time

#Inicializacion del programa

#Se toma el nombre de fichero TXT del parametro de entrada
#InputFile = str(sys.argv[1])
InputFile = str("exported_seq_INT.txt")
OutputFile = str(InputFile.split('.')[0])
#Se establece puerto de salida
InputPort = 12345
#Se inicializa escritura de fichero pcap para sopoerte de Preemption
pktdump = PcapWriter(OutputFile+".pcap", append = False, sync = True, linktype = 274)


#Lectura de fichero TXT que contiene la secuencia de tramas
with open(InputFile, 'r') as f:
    #Se lee fichero TXT como si fuera un CSV cuyo separador es un blanco ' '
    reader = csv.reader(f, dialect = 'excel', delimiter = ' ')

    #Para cada linea leida del fichero, se obtienen los datos de cada trama de la secuencia
    for linea in reader:
        print(linea)
        #Lectura de valor de tiempo de transmision de paquete
        tiempo_actual = int(linea[0])
        del linea[0]
        #Lectura de valor de longitud de paquete transmitido
        longitud_paquete = int (linea[0])
        del linea[0]
        #Limpieza de valores corruptos en caso de que los hubiera
        if '' in linea:
            linea.remove('')
        #Lectura de datos brutos del contenido del paquete transmitido (desde preamble hasta fsc)
        linea_raw = [chr(int(i)) for i in linea]
        #Conversion de datos brutos leidos a string para escritura en fichero pcap
        linea_str = ''.join(linea_raw)

        print(linea_str)
        
        #Se configuran los valores para escritura de paquete en fichero pcac
        pkt = Ether(linea_str)
        pkt.time = tiempo_actual/1e6 # tiempo en microsegundos (us)
        pkt.sniffed_on = "eth"+str(InputPort)

        pkt.show()
        #print("\t%f" % pkt.time)

        #Escritura de datos de paquete en fichero Pcap
        pktdump.write(pkt)
