----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 10.06.2019 10:44:01
-- Design Name: 
-- Module Name: Banco_Pruebas_Preemption - struct
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Banco_Pruebas_Preemption is
    Port (  clkInBP : in STD_LOGIC;
            dataOutBP : out STD_LOGIC_VECTOR (7 downto 0);
            readyInBP : in STD_LOGIC;
            validOutBP : out STD_LOGIC;
            clkOutBP : out STD_LOGIC;
            rstInBP : in STD_LOGIC;
            enableInBP : in STD_LOGIC);
end Banco_Pruebas_Preemption;

architecture struct of Banco_Pruebas_Preemption is

    -- Componentes
    component Data_Generator is
        Port ( mLengthInDG : in STD_LOGIC_VECTOR (7 downto 0);
               mGenDG : in STD_LOGIC;
               rstDG : in STD_LOGIC;
               clkDG : in STD_LOGIC;
               mLengthOutDG : out STD_LOGIC_VECTOR (7 downto 0);
               mDataDG : out STD_LOGIC_VECTOR (7 downto 0);
               mValidDG : out STD_LOGIC;
               mLastDG : out STD_LOGIC);
    end component;
    
    component Data_Control is
        Port ( rstInDC : in STD_LOGIC;
               clkInDC : in STD_LOGIC;
               enableInDC : in STD_LOGIC;
               eTxDC : in STD_LOGIC;
               pTxDC : in STD_LOGIC;
               eGenOutDC : out STD_LOGIC;
               pGenOutDC : out STD_LOGIC;
               mLengthOutDC : out STD_LOGIC_VECTOR (7 downto 0));
    end component;
    
    component Frame_Generator is
        Port ( mLengthFG : in STD_LOGIC_VECTOR (7 downto 0);
               mDataFG : in STD_LOGIC_VECTOR (7 downto 0);
               mValidFG : in STD_LOGIC;
               mLastFG : in STD_LOGIC;
               eGenFG : in STD_LOGIC;
               pGenFG : in STD_LOGIC;
               mLengthTotalFG : in STD_LOGIC_VECTOR (7 downto 0);
               enableFG : in STD_LOGIC;
               rstFG : in STD_LOGIC;
               clkFG : in STD_LOGIC;
               dataOutFG : out STD_LOGIC_VECTOR (7 downto 0);
               readyInFG : in STD_LOGIC;
               validOutFG : out STD_LOGIC;
               clkOutFG : out STD_LOGIC;
               header_genFG : out STD_LOGIC;
               data_genFG : out STD_LOGIC;
               eTxOutFG : out STD_LOGIC;
               pTxOutFG : out STD_LOGIC;
               rstGenFG : out STD_LOGIC);
    end component;
    
    component Data_Export is      
        Port ( clk : in STD_LOGIC;
               enable : in STD_LOGIC;
               data : in STD_LOGIC_VECTOR (7 downto 0));
    end component;
    -------------------------------------------
    -- Seales interconexion de bloques
    -------------------------------------------
    
    -------------------------------------------
    --General 
    -------------------------------------------
    --Inputs
    signal ready_sig : STD_LOGIC := '0';
    signal enable_sig :  STD_LOGIC := '0';
    signal rst_sig :  STD_LOGIC := '0'; 
    signal ready_and_enable :STD_LOGIC := '0';
    --Outputs
    --signal data_sig : STD_LOGIC_VECTOR (7 downto 0) := "00000000";
    signal valid_sig : STD_LOGIC := '0';
    signal clk_sig : STD_LOGIC := '0';
    signal clk_aux_sig : STD_LOGIC := '0';
    --Adecuacion de seales en ciclos de reloj
    signal data_retrasado1_sig : STD_LOGIC_VECTOR (7 downto 0) := "00000000";
    signal data_retrasado2_sig : STD_LOGIC_VECTOR (7 downto 0) := "00000000";
    signal data_retrasado3_sig : STD_LOGIC_VECTOR (7 downto 0) := "00000000";
    signal data_retrasado4_sig : STD_LOGIC_VECTOR (7 downto 0) := "00000000";
    signal data_aux_sig : STD_LOGIC_VECTOR (7 downto 0) := "00000000";
    signal data_retrasadoTotal1_sig : STD_LOGIC_VECTOR (7 downto 0) := "00000000";
    signal data_retrasadoTotal2_sig : STD_LOGIC_VECTOR (7 downto 0) := "00000000";
    signal data_auxTotal_sig : STD_LOGIC_VECTOR (7 downto 0) := "00000000";
    signal cambio_header_to_payload : STD_LOGIC := '0';
    signal cambio_payload_to_fsc : STD_LOGIC := '0';
    signal introduccion_dataOut : STD_LOGIC := '0';
    --signal header_gen_aux_sig : STD_LOGIC := '0';
    signal numero_ciclos_extra_header_sig : integer range 0 to 3 :=0;
    constant numero_ciclos_extra_header_cst : integer := 5; -- numero ciclos retraso menos 1 (3)
    signal data_gen_sig_ciclo_anterior :  STD_LOGIC := '0';
    signal numero_ciclos_extra_payload_sig : integer range 0 to 3 :=0;
    constant numero_ciclos_extra_payload_cst : integer := 3; -- numero ciclos retraso menos 1
    -------------------------------------------
    --Data Generator
    -------------------------------------------
    --Inputs
    signal mLengthIn_sig : STD_LOGIC_VECTOR (7 downto 0) := "00000000";
    signal rst_gen_sig : STD_LOGIC := '0';
    --Outputs
    signal mLength_sig : STD_LOGIC_VECTOR (7 downto 0) := "00000000";
    signal mData_sig : STD_LOGIC_VECTOR (7 downto 0) := "00000000";
    signal mValid_sig : STD_LOGIC := '0';
    signal mLast_sig : STD_LOGIC := '0';
  
    -------------------------------------------
    --Data Control
    -------------------------------------------
    --Inputs
    --Outputs
    signal eGen_sig : STD_LOGIC := '0';
    signal pGen_sig : STD_LOGIC := '0';
    signal mLengthTotal_sig : STD_LOGIC_VECTOR (7 downto 0) := "00000000";
    -------------------------------------------
    --Frame Generator
    -------------------------------------------
    --Inputs  
    signal readyIn_sig :  STD_LOGIC := '0';  
    --Outputs
    signal dataOut_sig :  STD_LOGIC_VECTOR (7 downto 0) := "00000000";
    signal validOut_sig :  STD_LOGIC := '0';
    signal validOut_retrasado1_sig :  STD_LOGIC := '0';
    signal validOut_retrasado2_sig :  STD_LOGIC := '0';
    signal clkOut_sig :  STD_LOGIC := '0';
    signal header_gen_sig :  STD_LOGIC := '0';
    signal data_gen_sig :  STD_LOGIC := '0';
    signal eTx_sig:  STD_LOGIC := '0';
    signal pTx_sig :  STD_LOGIC := '0';
    signal rstGen_sig :  STD_LOGIC := '0';

    -------------------------------------------
    --Data_Export
    -------------------------------------------
    --Inputs
    --Outputs

begin
    --------------------------------------------------------------------------------------
    -- Instanciacion de componentes (definicion de puertos y asignacion de seales)
    --------------------------------------------------------------------------------------

        GENERATOR: Data_Generator PORT MAP (
              mLengthInDG => mLengthTotal_sig,
              mGenDG => data_gen_sig,
              rstDG => rstGen_sig,
              clkDG => clk_sig,
              mLengthOutDG => mLength_sig,
              mDataDG => mData_sig,
              mValidDG => mValid_sig,
              mLastDG => mLast_sig
            );
            
          
        CONTROL: Data_Control PORT MAP (
                  rstInDC => rst_sig,
                  clkInDC => clk_sig,
                  --enableInDC => enable_sig,
                  enableInDC => ready_and_enable,
                  eTxDC => eTx_sig,
                  pTxDC => pTx_sig,
                  eGenOutDC => eGen_sig,
                  pGenOutDC => pGen_sig,
                  mLengthOutDC => mLengthTotal_sig
                ); 
    
        FRAME_GEN: Frame_Generator PORT MAP (
                  mLengthFG => mLength_sig,
                  mDataFG => mData_sig,
                  mValidFG => mValid_sig,
                  mLastFG => mLast_sig,
                  eGenFG => eGen_sig,
                  pGenFG => pGen_sig,
                  mLengthTotalFG => mLengthTotal_sig,
                  --enableFG => enable_sig,
                  enableFG => ready_and_enable,
                  rstFG => rst_sig,
                  clkFG => clk_sig,
                  dataOutFG => dataOut_sig,
                  readyInFG => readyIn_sig,
                  validOutFG => validOut_sig,
                  clkOutFG => clkOut_sig,
                  header_genFG => header_gen_sig,
                  data_genFG => data_gen_sig,
                  eTxOutFG => eTx_sig,
                  pTxOutFG => pTx_sig,
                  rstGenFG => rstGen_sig
            );
        
        DATA_EXP: Data_Export PORT MAP( 
                clk => clk_aux_sig,
                --enable => validOut_sig,
                enable => validOut_retrasado2_sig,
                data => data_auxTotal_sig
                --data => data_aux_sig
                );
       
    -------------------------------------------
    -- Decodificacion de puertos de salida
    -------------------------------------------
    process(clk_sig)
    begin
        if(clk_sig'event and clk_sig = '1') then
            if (readyIn_sig = '1' and enable_sig = '1') then
                ready_and_enable <= '1';
            else
                ready_and_enable <= '0';
            end if;
        end if;
    end process;
    
    process(clk_sig)
    begin
        if(clk_sig'event and clk_sig = '1') then
            clk_aux_sig <= '1';
        end if;
        
        if(clk_sig'event and clk_sig = '0') then
            clk_aux_sig <= '0';
        end if;
    end process;
    
    process(clk_sig)
    begin
        if(clk_sig'event and clk_sig = '1') then     
                 
            if (header_gen_sig = '1' and cambio_header_to_payload = '0') then
                --caso de retraso de cabecera             
                data_retrasado1_sig <= dataOut_sig;
                data_retrasado2_sig <= data_retrasado1_sig;
                data_retrasado3_sig <= data_retrasado2_sig;
                data_retrasado4_sig <= data_retrasado3_sig;
                data_aux_sig <= data_retrasado4_sig;  
                numero_ciclos_extra_header_sig <= 0; 
                introduccion_dataOut <= '1';
                cambio_payload_to_fsc <= '0';
            else
                if (cambio_header_to_payload = '0') then
                    --necesario mantener habilitacion n ciclos mas (siendo n el numero de ciclos a retrasar menos 1)
                    if (numero_ciclos_extra_header_sig = numero_ciclos_extra_header_cst) then
                        cambio_header_to_payload <= '1';
                        data_retrasado4_sig <= dataOut_sig;
                        data_aux_sig <= data_retrasado4_sig; 
                    else
                        numero_ciclos_extra_header_sig <= numero_ciclos_extra_header_sig + 1;
                        data_retrasado1_sig <= dataOut_sig;
                        data_retrasado2_sig <= data_retrasado1_sig;
                        data_retrasado3_sig <= data_retrasado2_sig;
                        data_retrasado4_sig <= data_retrasado3_sig;
                        data_aux_sig <= data_retrasado4_sig;
                    end if; 
              
                else
                    --primer ciclco de introduccion de datos de payload
                    if (introduccion_dataOut = '1') then
                        data_aux_sig <= dataOut_sig;
                        introduccion_dataOut <= '0'; 
                    else
                        --caso de sin retraso de datos
                        data_retrasado1_sig <= "00000000";
                        data_retrasado2_sig <= "00000000";
                        data_retrasado3_sig <= "00000000"; 
                        data_retrasado4_sig <= "00000000";   
                        data_aux_sig <= dataOut_sig;
                        
                        --controlamos cambio de payload a crc
                        if (cambio_payload_to_fsc = '0') then
                            --necesario mantener habilitacion n ciclos mas (siendo n el numero de ciclos a retrasar menos 1)
                            if (numero_ciclos_extra_payload_sig = numero_ciclos_extra_payload_cst) then
                                cambio_payload_to_fsc <= '1';
                            else
                                numero_ciclos_extra_header_sig <= numero_ciclos_extra_header_sig + 1;
                            end if;
                        end if;
                             
                        data_gen_sig_ciclo_anterior <= data_gen_sig;
                        if (data_gen_sig = '0' and data_gen_sig_ciclo_anterior = '1')then
                            cambio_payload_to_fsc <= '1';
                        end if;
                        
                        if (header_gen_sig = '0' and data_gen_sig = '0') then 
                            cambio_header_to_payload <= '0'; 
                        end if;
                        
                    end if;
                end if;
            end if;            
        end if;
    end process;
    
      --controlando desde fuera de frame generator
--    process(clk_sig)
--    begin
--        if(clk_sig'event and clk_sig = '1') then
--            if (cambio_payload_to_fsc = '0') then
--                --retrasamos 2 ciclos de reloj para adecuar a fsc
--                --data_retrasadoTotal1_sig <= data_aux_sig;
--                --data_retrasadoTotal2_sig <= data_retrasadoTotal1_sig;
                
--                --data_auxTotal_sig <= data_aux_sig;
--                data_auxTotal_sig(0) <= data_aux_sig(7);
--                data_auxTotal_sig(1) <= data_aux_sig(6);
--                data_auxTotal_sig(2) <= data_aux_sig(5);
--                data_auxTotal_sig(3) <= data_aux_sig(4);
--                data_auxTotal_sig(4) <= data_aux_sig(3);
--                data_auxTotal_sig(5) <= data_aux_sig(2);
--                data_auxTotal_sig(6) <= data_aux_sig(1);
--                data_auxTotal_sig(7) <= data_aux_sig(0);
--            else
--                --emitimos fsc directamente
--                --data_auxTotal_sig <= dataOut_sig;
--                data_auxTotal_sig(0) <= dataOut_sig(7);
--                data_auxTotal_sig(1) <= dataOut_sig(6);
--                data_auxTotal_sig(2) <= dataOut_sig(5);
--                data_auxTotal_sig(3) <= dataOut_sig(4);
--                data_auxTotal_sig(4) <= dataOut_sig(3);
--                data_auxTotal_sig(5) <= dataOut_sig(2);
--                data_auxTotal_sig(6) <= dataOut_sig(1);
--                data_auxTotal_sig(7) <= dataOut_sig(0);
--            end if;
--        end if;
--    end process;
    
    -- controlando desde dentro de frame generator
    process(clk_sig)
    begin
        if(clk_sig'event and clk_sig = '1') then
                data_auxTotal_sig(0) <= dataOut_sig(7);
                data_auxTotal_sig(1) <= dataOut_sig(6);
                data_auxTotal_sig(2) <= dataOut_sig(5);
                data_auxTotal_sig(3) <= dataOut_sig(4);
                data_auxTotal_sig(4) <= dataOut_sig(3);
                data_auxTotal_sig(5) <= dataOut_sig(2);
                data_auxTotal_sig(6) <= dataOut_sig(1);
                data_auxTotal_sig(7) <= dataOut_sig(0);
        end if;
    end process;
    
    process(clk_sig)
    begin
        if(clk_sig'event and clk_sig = '1') then
                validOut_retrasado1_sig <= validOut_sig;
                validOut_retrasado2_sig <= validOut_retrasado1_sig;
        end if;
    end process;
    
    --------------------------------------------------------------------------------------
    -- Asignaciones de seales a puertos y de puertos a seales
    --------------------------------------------------------------------------------------
    -- Inputs
    clk_sig <= clkInBP;
    readyIn_sig <= readyInBP; 
    rst_sig <= rstInBP;
    enable_sig <= enableInBP;
             
    --Outputs
    --dataOutBP <= dataOut_sig;
    --dataOutBP <= data_aux_sig;
    dataOutBP <= data_auxTotal_sig;
    --validOutBP <= validOut_sig;
    validOutBP <= validOut_retrasado2_sig;
    clkOutBP <= clk_aux_sig;

end struct;
