----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 20.03.2019 15:17:56
-- Design Name: 
-- Module Name: Data_Control - struct
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Data_Control is
    Port ( rstInDC : in STD_LOGIC;
           clkInDC : in STD_LOGIC;
           enableInDC : in STD_LOGIC;
           eTxDC : in STD_LOGIC;
           pTxDC : in STD_LOGIC;
           eGenOutDC : out STD_LOGIC;
           pGenOutDC : out STD_LOGIC;
           mLengthOutDC : out STD_LOGIC_VECTOR (7 downto 0));
end Data_Control;

architecture struct of Data_Control is

    -- Componentes
    component maquina_estados_generador 
       Port (  eTx_OK : in STD_LOGIC;
               pTx_OK : in STD_LOGIC;
               rst : in STD_LOGIC;
               clk : in STD_LOGIC;
               enable : in STD_LOGIC;
               sel : in STD_LOGIC_VECTOR (1 downto 0);
               eGen : out STD_LOGIC;
               pGen : out STD_LOGIC;
               enable_DataGen : out STD_LOGIC);
    end component;
    
    component control_tipo_paquete 
        Port ( rst : in STD_LOGIC;
               clk : in STD_LOGIC;
               enable : in STD_LOGIC;                       -- enable_DataGen de maquina de estados
               mSel : out STD_LOGIC_VECTOR (1 downto 0);    -- sel de maquina de estados
               mLength : out STD_LOGIC_VECTOR (7 downto 0));
    end component;
          
    -------------------------------------------
    -- Seales interconexion de bloques
    -------------------------------------------
    
    -------------------------------------------
    --General 
    -------------------------------------------
    --Inputs
    signal rstIn_sig : STD_LOGIC := '0';
    signal clkIn_sig :  STD_LOGIC := '0';
    signal enableIn_sig :  STD_LOGIC := '0'; 
    signal eTx_sig :  STD_LOGIC := '0'; 
    signal pTx_sig :  STD_LOGIC := '0'; 
    --Outputs
    signal eGenOut_sig : STD_LOGIC := '0';
    signal pGenOut_sig : STD_LOGIC := '0';
    signal mLengthOut_sig : STD_LOGIC_VECTOR (7 downto 0) := "00000000";

    

    signal sel_sig : STD_LOGIC_VECTOR (1 downto 0):= "00";
    signal enable_DataGen_sig: STD_LOGIC := '0';

    

begin

    -- Instanciacion de componentes (definicion de puertos y asignacion de seales)
    MAQESTADOS: maquina_estados_generador PORT MAP (
          eTx_OK => eTx_sig,
          pTx_OK => pTx_sig,
          rst => rstIN_sig,
          clk => clkIn_sig,
          enable => enableIn_sig,
          sel => sel_sig,
          eGen => eGenOut_sig,
          pGen => pGenOut_sig,
          enable_DataGen => enable_DataGen_sig
    );
    
    PAQCONTROL: control_tipo_paquete PORT MAP (
          rst => rstIN_sig,
          clk => clkIn_sig,
          enable => enable_DataGen_sig,
          mSel => sel_sig,
          mLength => mLengthOut_sig
    );
    
    -- Decodificacion de puertos de salida

    
-- Asignaciones de seales a puertos y de puertos a seales
-- Inputs
rstIn_sig <= rstInDC;
clkIn_sig <= clkInDC;
enableIn_sig <= enableInDC; 
eTx_sig <= eTxDC; 
pTx_sig <= pTxDC; 
--Outputs
eGenOutDC <= eGenOut_sig;
pGenOutDC <= pGenOut_sig;
mLengthOutDC <= mLengthOut_sig;


end struct;
