----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 14.06.2019 19:00:26
-- Design Name: 
-- Module Name: Data_Export - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------
-- Copyright (c) 2013 Jesus Lazaro Arrotegui
-------------------------------------------------------------------------------
-- Revisions  :
-- Date        Version  Author  Description
-- 2013-10-28  131028   jesus   Created
-- 2019-06-14   -       adrian  Modified
-------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_arith.all;
use std.textio.all;  
use ieee.std_logic_textio.all;  
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Data_Export is
    Generic (
        FILE_OUT_INT: string := "exported_seq_INT.txt";
        FILE_OUT_HEX: string := "exported_seq_HEX.txt";
        --DDR_IF : boolean := false;
        DATA_SIZE: positive := 8);
    
    Port ( clk : in STD_LOGIC;
           enable : in STD_LOGIC;
           data : in STD_LOGIC_VECTOR (7 downto 0));
end Data_Export;

architecture Behavioral of Data_Export is
   
    type ty_packet_data is array (0 to 10000) of std_logic_vector(7 downto 0); --array de std_logic_vector(7:0) para almacenamiento de octetos de salida 
    
begin
    -- write process
  writing :
  process
    file fileTXT_INT : text open write_mode is FILE_OUT_INT; --fichero de salida para exportacion de datos
    file fileTXT_HEX : text open write_mode is FILE_OUT_HEX; --fichero de salida para exportacion de datos
    variable outline_INT    : line;    --linea de fichero de salida para exportacion de datos
    variable outline_HEX    : line;    --linea de fichero de salida para exportacion de datos
    --variable timestamp     : integer;
    variable packet_length : integer := 0;
    variable packet_data   : ty_packet_data;
    --variable time_to_wait  : time;

    --variable start_of_packet          : time;
    --variable previous_start_of_packet : time := 0 ns;

    variable separador : character := ' ';

    --variable step             : integer := 0;
    --variable previous_phy_txd : std_logic_vector(DATA_SIZE-1 downto 0);

  begin

    while true loop
        wait until (rising_edge(clk));
        if (enable = '1') then

         -- [data -> array] 
        packet_data(packet_length) := data; -- store data       
        packet_length              := packet_length + 1;-- increase packet length
        
        end if;  

        if (enable = '0') then
            -- [array -> file]
            if packet_length > 0 then
            
              -- Tiempo actual
              write(outline_INT, NOW / 1 ns / 1000);
              write(outline_INT, separador);
              write(outline_HEX, NOW / 1 ns / 1000);
              write(outline_HEX, separador);
            
              -- Longitud de paquete
              write(outline_INT, packet_length-1);
              write(outline_INT, separador);
              write(outline_HEX, packet_length-1);
              write(outline_HEX, separador);
            
              -- Datos de paquete
              for I in 0 to (packet_length-1) loop
                if ( (I > (packet_length-1-5) or I = 0) and conv_integer(packet_data(I)) = 0) then
                    --limpiamos valores nulos al final
                else
                    write(outline_INT, conv_integer(packet_data(I)));
                    write(outline_INT, separador);
                    hwrite(outline_HEX, packet_data(I));
                    write(outline_HEX, separador);
                end if;
              end loop; 
            
              -- Linea -> Fichero
              writeline(fileTXT_INT, outline_INT);
              writeline(fileTXT_HEX, outline_HEX);
              
            
              -- update length
              packet_length := 0;
            end if;
        end if;       

    end loop;

    wait;
  end process writing;

---- always write per byte
--  type ty_packet_data is array (0 to 10000) of std_logic_vector(7 downto 0);

--begin  -- architecture phy_tx_tb_131028

--  -- write process
--  writing :
--  process
--    file outfile           : text open write_mode is FILE_OUT;  --declare input file
--    variable outline       : line;      --line number declaration
--    variable timestamp     : integer;
--    variable packet_length : integer := 0;
--    variable packet_data   : ty_packet_data;
--    variable time_to_wait  : time;

--    variable start_of_packet          : time;
--    variable previous_start_of_packet : time := 0 ns;

--    variable spacer : character := ' ';

--    variable step             : integer := 0;
--    variable previous_phy_txd : std_logic_vector(DATA_SIZE-1 downto 0);


--  begin

--    while true loop
--      wait until rising_edge(clk) or (falling_edge(clk) and DDR_IF);
--      if enable = '1' then

--        -- first byte in packet
--        if packet_length = 0 and step = 0 then
--          start_of_packet := NOW;
--          step            := 0;
--        end if;

--        if not DDR_IF then
--          -- store data
--          packet_data(packet_length) := data;
--          -- increase packet length
--          packet_length              := packet_length + 1;
--        end if;

--        if DDR_IF then
--          if step = 1 then
--            -- store data
--            packet_data(packet_length) := data & previous_phy_txd;
--            -- increase packet length
--            packet_length              := packet_length + 1;
--            step                       := 0;
--          else
--            previous_phy_txd := data;
--            step             := step + 1;
--          end if;
--        end if;

--      end if;

--      if enable = '0' then
--        -- data to store
--        if packet_length > 0 then
--          timestamp := (start_of_packet - previous_start_of_packet) / 1 ns / 1000;

--          previous_start_of_packet := start_of_packet;
--          -- store timestamp
--          write(outline, NOW / 1 ns / 1000);
--          write(outline, spacer);
--          write(outline, timestamp);
--          write(outline, spacer);

--          -- store length
--          write(outline, packet_length-1);
--          write(outline, spacer);

--          -- store data
--          for I in 0 to packet_length-1 loop
--            write(outline, conv_integer(packet_data(I)));
--            write(outline, spacer);
--          end loop;  -- I


--          -- write line
--          writeline(outfile, outline);

--          -- update length
--          packet_length := 0;
--        end if;
--      end if;

--    end loop;

--    wait;
--  end process writing;



end Behavioral;
