----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 02.03.2019 16:16:54
-- Design Name: 
-- Module Name: Data_Generator - struct
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Data_Generator is
    Port ( mLengthInDG : in STD_LOGIC_VECTOR (7 downto 0);
           mGenDG : in STD_LOGIC;
           rstDG : in STD_LOGIC;
           clkDG : in STD_LOGIC;
           mLengthOutDG : out STD_LOGIC_VECTOR (7 downto 0);
           mDataDG : out STD_LOGIC_VECTOR (7 downto 0);
           mValidDG : out STD_LOGIC;
           mLastDG : out STD_LOGIC);
end Data_Generator;

architecture struct of Data_Generator is
    
    -- Componentes
    component contador_dsc 
       Port (  enable : in STD_LOGIC;
               rst : in STD_LOGIC;
               start_count_val : in STD_LOGIC_VECTOR (7 downto 0);
               generating : out STD_LOGIC;
               ending : out STD_LOGIC;
               mLength : out STD_LOGIC_VECTOR (7 downto 0);
               clk : in STD_LOGIC);
    end component;
    
    component number_generator 
        Port ( enable : in STD_LOGIC;                       -- generating del bloque contador
               last : in STD_LOGIC;                         -- last del bloque contador
               clk : in STD_LOGIC;
               rst : in STD_LOGIC;
               mData : out STD_LOGIC_VECTOR (7 downto 0);   -- datos del paquete generado
               mValid : out STD_LOGIC;                      -- indicador de paquete generado listo
               mLast : out STD_LOGIC;                       -- indicador de ultimo paquete generado listo
               mLength : in STD_LOGIC_VECTOR (7 downto 0)); -- tamao del paquete generado
    end component;
          
    -- Seales interconexion de bloques
    signal enable_sig: STD_LOGIC := '0';
    signal rst_sig : STD_LOGIC := '0';
    signal last_sig : STD_LOGIC := '0';
    signal mLength_sig : STD_LOGIC_VECTOR (7 downto 0) := "00000000";
    signal clk_sig : STD_LOGIC := '0';
    
    signal mValid_sig: STD_LOGIC := '0';
    signal mLast_sig : STD_LOGIC := '0';
    signal mData_sig : STD_LOGIC_VECTOR (7 downto 0) := "00000000";
        
    signal start_count_val_sig : STD_LOGIC_VECTOR (7 downto 0) := "00000000";
    
    signal generating_sig: STD_LOGIC := '0';
    signal ending_sig : STD_LOGIC := '0';
    

begin

    -- Instanciacion de componentes (definicion de puertos y asignacion de seales)
    CONTADOR: contador_dsc PORT MAP (
          enable => enable_sig,
          rst => rst_sig,
          start_count_val => start_count_val_sig,
          generating => generating_sig,
          ending => ending_sig,
          clk => clk_sig,
          mLength => mLength_sig
    );
    
    GENERADOR: number_generator PORT MAP (
          enable => generating_sig,
          last => ending_sig,
          clk => clk_sig,
          rst => rst_sig,
          mData => mData_sig,
          mValid => mValid_sig,
          mLast => mLast_sig,
          mLength => mLength_sig
    );
    
    -- Decodificacion de puertos de salida

    
    -- Asignaciones de seales a puertos y de puertos a seales
    -- Inputs
    start_count_val_sig <= mLengthInDG;
    enable_sig <= mGenDG;
    rst_sig <= rstDG;
    clk_sig <= clkDG;
    --Outputs
    mLengthOutDG <= mLength_sig;
    mDataDG <= mData_sig;
    mValidDG <= mValid_sig;
    mLastDG <= mLast_sig;


end struct;
