----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 08.06.2019 19:13:31
-- Design Name: 
-- Module Name: select_generated_data - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity select_generated_data is
    Port (  clk : in STD_LOGIC;
            preamble : in STD_LOGIC_VECTOR (7 downto 0);
            payload : in STD_LOGIC_VECTOR (7 downto 0);
            fsc : in STD_LOGIC_VECTOR (7 downto 0);
            sel : in STD_LOGIC_VECTOR (3 downto 0);
            data : out STD_LOGIC_VECTOR (7 downto 0));
end select_generated_data;

architecture Behavioral of select_generated_data is

    --seales para entradas
    signal clk_sig :        STD_LOGIC                     := '0';
    signal preamble_sig :   STD_LOGIC_VECTOR (7 downto 0) := "00000000";
    signal payload_sig :    STD_LOGIC_VECTOR (7 downto 0) := "00000000";
    signal fsc_sig :        STD_LOGIC_VECTOR (7 downto 0) := "00000000";
    signal sel_sig :        STD_LOGIC_VECTOR (3 downto 0)     := "0000";  
    --seales para salidas
    signal data_sig :       STD_LOGIC_VECTOR (7 downto 0) := "00000000";
    
    
    --seales para control de salidas en funcion de entradas
    signal siguiente_salida : STD_LOGIC_VECTOR (7 downto 0) := "00000000";
    
    -- constantes para valores de entrada
    constant no_select_gen                      : STD_LOGIC_VECTOR (3 downto 0)   := "0000";
    constant select_preamble_gen                : STD_LOGIC_VECTOR (3 downto 0)   := "1000";
    constant select_preamble_payload_fsc_gen    : STD_LOGIC_VECTOR (3 downto 0)   := "1110";
    constant select_payload_gen                 : STD_LOGIC_VECTOR (3 downto 0)   := "0100";
    constant select_fsc_gen                     : STD_LOGIC_VECTOR (3 downto 0)   := "0010";
    constant select_fsc_gen_aux                 : STD_LOGIC_VECTOR (3 downto 0)   := "0110";
    constant select_gap_gen                     : STD_LOGIC_VECTOR (3 downto 0)   := "0001";
    
    -- constantes para valores de salida
    constant no_val : STD_LOGIC_VECTOR (7 downto 0) := "00000000";
    
begin

    process(clk_sig)
    begin
        if (clk_sig'event and clk_sig = '1') then
            data_sig <= siguiente_salida;
        end if;
    end process;

with sel_sig select
        siguiente_salida <= preamble_sig    when    select_preamble_gen,
                            preamble_sig    when    select_preamble_payload_fsc_gen,
                            payload_sig     when    select_payload_gen,
                            payload_sig     when    select_fsc_gen_aux,
                            fsc_sig         when    select_fsc_gen,                            
                            no_val          when    others;


--Asignacion de entradas a seales internas
clk_sig <= clk;
preamble_sig <= preamble;
payload_sig <= payload;
fsc_sig <= fsc;
sel_sig <= sel;
--Asignacion de seales internas a salidas
data <= data_sig;


end Behavioral;
