----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 20.03.2019 15:53:49
-- Design Name: 
-- Module Name: testbench_Data_Control - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity testbench_Data_Control is
--  Port ( );
end testbench_Data_Control;

architecture Behavioral of testbench_Data_Control is

    component Data_Control is
        Port ( rstInDC : in STD_LOGIC;
               clkInDC : in STD_LOGIC;
               enableInDC : in STD_LOGIC;
               eTxDC : in STD_LOGIC;
               pTxDC : in STD_LOGIC;
               eGenOutDC : out STD_LOGIC;
               pGenOutDC : out STD_LOGIC;
               mLengthOutDC : out STD_LOGIC_VECTOR (7 downto 0));
    end component;
    
    --Inputs
    signal eTx_sig : STD_LOGIC := '0';
    signal pTx_sig : STD_LOGIC := '0';
    signal rst_sig : STD_LOGIC := '0';
    signal clk_sig : STD_LOGIC := '0';
    signal enable_sig : STD_LOGIC := '0';
    --Outputs
    signal eGenOut_sig : STD_LOGIC := '0';
    signal pGenOut_sig : STD_LOGIC := '0';
    signal mLengthOut_sig : STD_LOGIC_VECTOR (7 downto 0) := "00000000";
    
    --Clock period definition
    constant clk_period : time := 20 ns; --Seal de 50Mhz

begin
    -- Instantiate the Unit Under Test (UUT)
    UUT: Data_Control PORT MAP (
          rstInDC => rst_sig,
          clkInDC => clk_sig,
          enableInDC => enable_sig,
          eTxDC => eTx_sig,
          pTxDC => pTx_sig,
          eGenOutDC => eGenOut_sig,
          pGenOutDC => pGenOut_sig,
          mLengthOutDC => mLengthOut_sig
        );

                       
    
    -- Clock process definitions
    clk_process :process
    begin
        clk_sig <= '0';
        wait for clk_period/2;
        clk_sig <= '1';
        wait for clk_period/2;
    end process;
    
    -- Stimulus process
    stim_proc: process
    begin        
      -- hold reset state for 100 ns.
        eTx_sig <= '0';
        pTx_sig <= '0';
        enable_sig <= '0';
        
        rst_sig <='1';
        wait for 50 ns;    
        rst_sig <='0';
        wait for 50 ns;
        
        
        enable_sig <= '1';
        wait for 500 ns;
  
  
        eTx_sig <= '1';
        wait for 50 ns;
        
        eTx_sig <= '0';
        
        wait for clk_period*20;
    
      wait;
    end process;

end Behavioral;
