----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 22.05.2019 17:39:34
-- Design Name: 
-- Module Name: testbench_Frame_Generator - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.numeric_std.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity testbench_Frame_Generator is
--  Port ( );
end testbench_Frame_Generator;

architecture Behavioral of testbench_Frame_Generator is
    component Frame_Generator is
        Port ( mLengthFG : in STD_LOGIC_VECTOR (7 downto 0);
               mDataFG : in STD_LOGIC_VECTOR (7 downto 0);
               mValidFG : in STD_LOGIC;
               mLastFG : in STD_LOGIC;
               eGenFG : in STD_LOGIC;
               pGenFG : in STD_LOGIC;
               mLengthTotalFG : in STD_LOGIC_VECTOR (7 downto 0);
               enableFG : in STD_LOGIC;
               rstFG : in STD_LOGIC;
               clkFG : in STD_LOGIC;
               dataOutFG : out STD_LOGIC_VECTOR (7 downto 0);
               readyInFG : in STD_LOGIC;
               validOutFG : out STD_LOGIC;
               clkOutFG : out STD_LOGIC;
               header_genFG : out STD_LOGIC;
               data_genFG : out STD_LOGIC;
               eTxOutFG : out STD_LOGIC;
               pTxOutFG : out STD_LOGIC;
               rstGenFG : out STD_LOGIC);
    end component;
    
    --Inputs
    signal mLength_sig :  STD_LOGIC_VECTOR (7 downto 0) := "00000000";
    signal mData_sig :  STD_LOGIC_VECTOR (7 downto 0) := "00000000";
    signal mValid_sig :  STD_LOGIC := '0';
    signal mLast_sig :  STD_LOGIC := '0';
    signal eGen_sig :  STD_LOGIC := '0';
    signal pGen_sig :  STD_LOGIC := '0';
    signal mLengthTotal_sig :  STD_LOGIC_VECTOR (7 downto 0) := "00000000";
    signal enable_sig :  STD_LOGIC := '0';
    signal rst_sig :  STD_LOGIC := '0';
    signal clk_sig :  STD_LOGIC := '0';
    signal readyIn_sig :  STD_LOGIC := '0';   
    --Outputs
    signal dataOut_sig :  STD_LOGIC_VECTOR (7 downto 0) := "00000000";
    signal validOut_sig :  STD_LOGIC := '0';
    signal clkOut_sig :  STD_LOGIC := '0';
    signal header_gen_sig :  STD_LOGIC := '0';
    signal data_gen_sig :  STD_LOGIC := '0';
    signal eTx_sig:  STD_LOGIC := '0';
    signal pTx_sig :  STD_LOGIC := '0';
    signal rstGen_sig :  STD_LOGIC := '0';
    
    --Clock period definition
    constant clk_period : time := 20 ns; --Seal de 50Mhz
begin
    -- Instantiate the Unit Under Test (UUT)
    UUT: Frame_Generator PORT MAP (
          mLengthFG => mLength_sig,
          mDataFG => mData_sig,
          mValidFG => mValid_sig,
          mLastFG => mLast_sig,
          eGenFG => eGen_sig,
          pGenFG => pGen_sig,
          mLengthTotalFG => mLengthTotal_sig,
          enableFG => enable_sig,
          rstFG => rst_sig,
          clkFG => clk_sig,
          dataOutFG => dataOut_sig,
          readyInFG => readyIn_sig,
          validOutFG => validOut_sig,
          clkOutFG => clkOut_sig,
          header_genFG => header_gen_sig,
          data_genFG => data_gen_sig,
          eTxOutFG => eTx_sig,
          pTxOutFG => pTx_sig,
          rstGenFG => rstGen_sig
        );
                       
    
    -- Clock process definitions
    clk_process :process
    begin
        clk_sig <= '0';
        wait for clk_period/2;
        clk_sig <= '1';
        wait for clk_period/2;
    end process;
    
    -- Stimulus process
    stim_proc: process
    begin        
      -- hold reset state for 100 ns.
        enable_sig <= '0';
        mData_sig <= "11110000";
        mLengthTotal_sig <= std_logic_vector(to_unsigned(60,mLengthTotal_sig'length));
        mValid_sig <= '1';
        mLast_sig <= '0';
        readyIn_sig <= '1';
        eGen_sig <= '0';
        pGen_sig <= '0';
        
        rst_sig <='1';
        wait for 50 ns;    
        rst_sig <='0';
        wait for 50 ns;
        
        ------------------------------------------------------------
        --Generacion de pPacket 
        ------------------------------------------------------------
--        pGen_sig <= '1';      
        
--        enable_sig <= '1';
--        wait for clk_period*100;

        
--        mLast_sig <= '1';
--        wait for clk_period*2;
        
--        eGen_sig <= '0';
--        pGen_sig <= '0';
--        wait for clk_period*20;
    
        ------------------------------------------------------------
        --Generacion de ePacket 
        ------------------------------------------------------------
--        eGen_sig <= '1';      
        
--        enable_sig <= '1';
--        wait for clk_period*100;

        
--        mLast_sig <= '1';
--        wait for clk_period*2;
        
--        eGen_sig <= '0';
--        pGen_sig <= '0';
--        wait for clk_period*20;
    
    
        ------------------------------------------------------------
        --Generacion de 2 pPacket 
        ------------------------------------------------------------
--        pGen_sig <= '1';      
        
--        enable_sig <= '1';
--        wait for clk_period*100;

        
--        mLast_sig <= '1';
--        wait for clk_period*2;
        
--        eGen_sig <= '0';
--        pGen_sig <= '0';
--        mLast_sig <= '0';
--        wait for clk_period*20;
        
--        pGen_sig <= '1';      
                
--        enable_sig <= '1';
--        wait for clk_period*100;

        
--        mLast_sig <= '1';
--        wait for clk_period*2;
        
--        eGen_sig <= '0';
--        pGen_sig <= '0';
--        wait for clk_period*20;
    
        ---------------------------------------------------------------------------------------
        --Generacion de pPacket (con interrupcion de ePacket y continuacion de pPacket)
        ---------------------------------------------------------------------------------------
        pGen_sig <= '1';      
        
        enable_sig <= '1';
        wait for clk_period*50;

        eGen_sig <= '1';
        wait for clk_period*150;
        
        mLast_sig <= '1';
        wait for clk_period*2;
        
        eGen_sig <= '0';
        pGen_sig <= '0';
        mLast_sig <= '0';
        wait for clk_period*20;
        
        pGen_sig <= '1';  
        wait for clk_period*75;
                
        mLast_sig <= '1';
        wait for clk_period*2;
        
        eGen_sig <= '0';
        pGen_sig <= '0';
        mLast_sig <= '0';
        wait for clk_period*20;
      wait;
    end process;

end Behavioral;
