----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 01.03.2019 20:17:35
-- Design Name: 
-- Module Name: testbench_contador - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity testbench_contador is
--  Port ( );
end testbench_contador;

architecture Behavioral of testbench_contador is

    component contador_dsc 
   Port (  enable : in STD_LOGIC;
           rst : in STD_LOGIC;
           start_count_val : in STD_LOGIC_VECTOR (7 downto 0);
           generating : out STD_LOGIC;
           ending : out STD_LOGIC;
           mLength : out STD_LOGIC_VECTOR (7 downto 0);
           clk : in STD_LOGIC);
    end component;
    
    --Inputs
    signal enable_sig: STD_LOGIC := '0';
    signal rst_sig : STD_LOGIC := '0';
    signal start_count_val_sig : STD_LOGIC_VECTOR (7 downto 0) := "00000000";
    signal clk_sig : STD_LOGIC := '0';
    
    --Outputs
    signal generating_sig: STD_LOGIC := '0';
    signal ending_sig : STD_LOGIC := '0';
    signal mLength_sig : STD_LOGIC_VECTOR (7 downto 0) := "00000000";
    
    --Clock period definition
    constant clk_period : time := 20 ns; --Seal de 50Mhz
       
begin
    -- Instantiate the Unit Under Test (UUT)
    UUT: contador_dsc PORT MAP (
          enable => enable_sig,
          rst => rst_sig,
          start_count_val => start_count_val_sig,
          generating => generating_sig,
          ending => ending_sig,
          clk => clk_sig,
          mLength => mLength_sig
        );
    
    -- Clock process definitions
    clk_process :process
    begin
        clk_sig <= '0';
        wait for clk_period/2;
        clk_sig <= '1';
        wait for clk_period/2;
    end process;
    
    -- Stimulus process
    stim_proc: process
    begin        
      -- hold reset state for 100 ns.
        start_count_val_sig <= "00111010";
        rst_sig <='1';
        wait for 50 ns;    
        rst_sig <='0';
        wait for 10 ns;
        
        enable_sig <= '1';   
        wait for clk_period*10;
    
      wait;
    end process;

end Behavioral;
