----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 09.06.2019 17:34:19
-- Design Name: 
-- Module Name: testbench_frame_generator_control - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity testbench_frame_generator_control is
--  Port ( );
end testbench_frame_generator_control;

architecture Behavioral of testbench_frame_generator_control is
    component frame_generator_control is
    Port ( enable : in STD_LOGIC;
           eGen : in STD_LOGIC;
           pGen : in STD_LOGIC;
           mValid : in STD_LOGIC;
           mLast : in STD_LOGIC;
           rst : in STD_LOGIC;
           clk : in STD_LOGIC;
           mGen : out STD_LOGIC;
           eTx : out STD_LOGIC;
           pTx : out STD_LOGIC;
           rstGen : out STD_LOGIC;
           pInterrupt: out STD_LOGIC;
           ready : in STD_LOGIC;
           valid : out STD_LOGIC);
    end component;
   
   --Inputs
   signal enable_sig : STD_LOGIC := '0';
   signal eGen_sig : STD_LOGIC := '0';
   signal pGen_sig : STD_LOGIC := '0';
   signal mValid_sig : STD_LOGIC := '0';
   signal mLast_sig : STD_LOGIC := '0';
   signal rst_sig : STD_LOGIC := '0';
   signal clk_sig : STD_LOGIC := '0';
   signal ready_sig : STD_LOGIC := '0';
   
   --Outputs
   signal mGen_sig : STD_LOGIC := '0';
   signal eTx_sig : STD_LOGIC := '0';
   signal pTx_sig : STD_LOGIC := '0';
   signal rstGen_sig : STD_LOGIC := '0';
   signal pInterrupt_sig : STD_LOGIC := '0';
   signal valid_sig : STD_LOGIC := '0';
   
   --Clock period definition
   constant clk_period : time := 20 ns; --Seal de 50Mhz
begin
    -- Instantiate the Unit Under Test (UUT)
    UUT: frame_generator_control PORT MAP (
          enable => enable_sig,
          eGen => eGen_sig,
          pGen => pGen_sig,
          mValid => mValid_sig,
          mLast => mLast_sig,
          rst => rst_sig,
          clk => clk_sig,
          mGen => mGen_sig,
          eTx => eTx_sig,
          pTx => pTx_sig,
          rstGen => rstGen_sig,
          pInterrupt => pInterrupt_sig,
          ready => ready_sig,
          valid => valid_sig
          );

    -- Clock process definitions
    clk_process :process
    begin
        clk_sig <= '0';
        wait for clk_period/2;
        clk_sig <= '1';
        wait for clk_period/2;
    end process;
    
    -- Stimulus process
    stim_proc: process
    begin        
      -- hold reset state for 100 ns.
        rst_sig <= '1';
        wait for clk_period*2;
        
        rst_sig <= '0';
        wait for clk_period*2;
        
        ------------------------------------------------------------------------------------
        --Generacion de pPacket (completo)
        ------------------------------------------------------------------------------------
--        mValid_sig <= '1';
--        enable_sig <= '1';
--        pGen_sig <= '1';
--        wait for clk_period*60;
        
--        mLast_sig <= '1';
--        wait for clk_period*2;
        
        
--        pGen_sig <= '0';
--        eGen_sig <= '0';
--        wait for clk_period*10;
        
        
        ------------------------------------------------------------------------------------
        --Generacion de ePacket
        ------------------------------------------------------------------------------------
--        mValid_sig <= '1';
--        enable_sig <= '1';
--        eGen_sig <= '1';
--        wait for clk_period*60;
        
--        mLast_sig <= '1';
--        wait for clk_period*2;
        
        
--        pGen_sig <= '0';
--        eGen_sig <= '0';
--        wait for clk_period*10;
        
        
        ------------------------------------------------------------------------------------
        --Generacion de pPacket (con interrucion por ePacket y continuacion de pPacket)
        ------------------------------------------------------------------------------------
        mValid_sig <= '1';
        enable_sig <= '1';
        pGen_sig <= '1';
        wait for clk_period*25;
        
        eGen_sig <= '1';
        wait for clk_period*30;   
        mLast_sig <= '1';
        wait for clk_period*2;
             
        pGen_sig <= '0';
        eGen_sig <= '0';
        wait for clk_period*2;

        pGen_sig <= '1';
        wait for clk_period*60;
        
        mLast_sig <= '1';
        wait for clk_period*2;
        
        
        pGen_sig <= '0';
        eGen_sig <= '0';
        wait for clk_period*10;
        
        ------------------------
        --Fin
        ------------------------
    
      wait;
    end process;

end Behavioral;
