----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 01.03.2019 20:17:35
-- Design Name: 
-- Module Name: testbench_contador - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity testbench_generador_datos is
--  Port ( );
end testbench_generador_datos;

architecture Behavioral of testbench_generador_datos is
    
    component number_generator 
        Port ( enable : in STD_LOGIC;                       -- generating del bloque contador
               last : in STD_LOGIC;                         -- last del bloque contador
               clk : in STD_LOGIC;
               rst : in STD_LOGIC;
               mData : out STD_LOGIC_VECTOR (7 downto 0);   -- datos del paquete generado
               mValid : out STD_LOGIC;                      -- indicador de paquete generado listo
               mLast : out STD_LOGIC;                       -- indicador de ultimo paquete generado listo
               mLength : in STD_LOGIC_VECTOR (7 downto 0)); -- tamao del paquete generado
    end component;
    
    --Inputs
    signal enable_sig: STD_LOGIC := '0';
    signal rst_sig : STD_LOGIC := '0';
    signal last_sig : STD_LOGIC := '0';
    signal mLength_sig : STD_LOGIC_VECTOR (7 downto 0) := "00000000";
    signal clk_sig : STD_LOGIC := '0';
    
    --Outputs
    signal mValid_sig: STD_LOGIC := '0';
    signal mLast_sig : STD_LOGIC := '0';
    signal mData_sig : STD_LOGIC_VECTOR (7 downto 0) := "00000000";

    
    --Clock period definition
    constant clk_period : time := 20 ns; --Seal de 50Mhz
       
begin
    -- Instantiate the Unit Under Test (UUT)
    UUT: number_generator PORT MAP (
          enable => enable_sig,
          last => last_sig,
          clk => clk_sig,
          rst => rst_sig,
          mData => mData_sig,
          mValid => mValid_sig,
          mLast => mLast_sig,
          mLength => mLength_sig
        );
    
    -- Clock process definitions
    clk_process :process
    begin
        clk_sig <= '0';
        wait for clk_period/2;
        clk_sig <= '1';
        wait for clk_period/2;
    end process;
    
    -- Stimulus process
    stim_proc: process
    begin        
      -- hold reset state for 100 ns.
        
        mLength_sig <= "00001000";
        rst_sig <='1';
        wait for 50 ns;    
        rst_sig <='0';
        wait for 10 ns;
        enable_sig <= '1';
        wait for clk_period*5; 
        
        mLength_sig <= "00000010";
        last_sig <= '1';    
        wait for clk_period*2;
        rst_sig <='1';
        wait for 50 ns;    
        rst_sig <='0';
        wait for 10 ns;
         
        wait for clk_period*10;
    
      wait;
    end process;

end Behavioral;
