----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 02.03.2019 15:08:08
-- Design Name: 
-- Module Name: testbench_maquina_estados_generador - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity testbench_maquina_estados_generador is
--  Port ( );
end testbench_maquina_estados_generador;

architecture Behavioral of testbench_maquina_estados_generador is

    component maquina_estados_generador 
        Port ( eTx_OK : in STD_LOGIC;
               pTx_OK : in STD_LOGIC;
               rst : in STD_LOGIC;
               clk : in STD_LOGIC;
               enable : in STD_LOGIC;
               sel : in STD_LOGIC_VECTOR (1 downto 0);
               eGen : out STD_LOGIC;
               pGen : out STD_LOGIC;
               enable_DataGen : out STD_LOGIC);
    end component;

    --Inputs
     signal eTx_OK_sig : STD_LOGIC := '0';
     signal pTx_OK_sig : STD_LOGIC := '0';
     signal rst_sig : STD_LOGIC := '0';
     signal clk_sig : STD_LOGIC := '0';
     signal enable_sig : STD_LOGIC := '0';
     signal sel_sig : STD_LOGIC_VECTOR (1 downto 0) := "00";
    
    --Outputs
    signal eGen_sig : STD_LOGIC := '0';
    signal pGen_sig : STD_LOGIC := '0';
    signal enable_DataGen_sig : STD_LOGIC := '0';

    
    --Clock period definition
    constant clk_period : time := 20 ns; --Seal de 50Mhz

begin

    -- Instantiate the Unit Under Test (UUT)
    UUT: maquina_estados_generador PORT MAP (
          eTx_OK => eTx_OK_sig,
          pTx_OK => pTx_OK_sig,
          rst => rst_sig,
          clk => clk_sig,
          enable => enable_sig,
          sel => sel_sig,
          eGen => eGen_sig,
          pGen => pGen_sig,
          enable_DataGen => enable_DataGen_sig
        );
    
    -- Clock process definitions
    clk_process :process
    begin
        clk_sig <= '0';
        wait for clk_period/2;
        clk_sig <= '1';
        wait for clk_period/2;
    end process;
    
    -- Stimulus process
    stim_proc: process
    begin        
      -- hold reset state for 100 ns.
        
        -- reset
        rst_sig <='1';
        wait for 50 ns;    
        rst_sig <='0';
        wait for 50 ns;
        
        -- generamos Express Packet
        eTx_OK_sig <= '0';
        pTx_OK_sig <= '0';
        sel_sig <= "10";
        wait for 100ns;
        
        -- terminamos Express Packet y pasamos a generar Preemptable Packet
        sel_sig <= "01";
        eTx_OK_sig <= '1';
        wait for 100ns;
        
        -- generamos Preemtable Packet
        eTx_OK_sig <= '0';
        pTx_OK_sig <= '0';
        sel_sig <= "01";
        wait for 100ns;
        
        -- terminamos Preemptable Packet y generamos otro Preemptable Packet
        sel_sig <= "01";
        pTx_OK_sig <= '1';
        wait for 50ns;
        
        -- generamos Preemtable Packet e interrumpimos para generar Express Packet
        eTx_OK_sig <= '0';
        pTx_OK_sig <= '0';
        wait for 10ns;
        sel_sig <= "11";
        wait for 50ns;
        
        -- terminamos Express Packet y pasamos a espera
        sel_sig <= "00";
        eTx_OK_sig <= '1';
        wait for 100ns;
        
      
        wait for clk_period*10;
    
      wait;
    end process;

end Behavioral;
