----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 22.05.2019 17:43:52
-- Design Name: 
-- Module Name: testbench_preamble_generator - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity testbench_preamble_generator is
--  Port ( );
end testbench_preamble_generator;

architecture Behavioral of testbench_preamble_generator is

   component preamble_generator 
   Port ( clk : in STD_LOGIC;
          enable_generate : in STD_LOGIC;
          pInterrupt : in STD_LOGIC;
          eGen : in STD_LOGIC;
          pGen : in STD_LOGIC;
          preamble : out STD_LOGIC_VECTOR (7 downto 0);
          ended : out STD_LOGIC;
          valid : out STD_LOGIC);
    end component;
    
    --Inputs
    signal clk_sig :  STD_LOGIC := '0';
    signal enable_generate_sig :  STD_LOGIC := '0';
    signal pInterrupt_sig :  STD_LOGIC := '0';
    signal eGen_sig :  STD_LOGIC := '0';
    signal pGen_sig :  STD_LOGIC := '0';
    
    --Outputs
    signal preamble_sig : STD_LOGIC_VECTOR (7 downto 0) := "00000000";
    signal ended_sig :  STD_LOGIC := '0';
    signal valid_sig :  STD_LOGIC := '0';
    
    --Clock period definition
    constant clk_period : time := 20 ns; --Seal de 50Mhz
       
begin
    -- Instantiate the Unit Under Test (UUT)
    UUT: preamble_generator PORT MAP (
          clk => clk_sig,
          enable_generate => enable_generate_sig,
          pInterrupt => pInterrupt_sig,
          eGen => eGen_sig,
          pGen => pGen_sig,
          preamble => preamble_sig,
          ended => ended_sig
          );
    
    -- Clock process definitions
    clk_process :process
    begin
        clk_sig <= '0';
        wait for clk_period/2;
        clk_sig <= '1';
        wait for clk_period/2;
    end process;
    
    -- Stimulus process
    stim_proc: process
    begin        
      -- hold reset state for 100 ns.
        pGen_sig <= '0';
        eGen_sig <= '0';
        enable_generate_sig <= '0';
        wait for clk_period*5;
        
        -- Generamos el preamble de un pPacket (completo o primer frag.)
        pGen_sig <= '1';
        enable_generate_sig <= '1';
        wait for clk_period*50;
        
        pGen_sig <= '0';
        eGen_sig <= '0';
        enable_generate_sig <= '0';
        wait for clk_period*10;
       
        -- Generamos el preamble de un frag. pPacket (no primer frag.)
        pInterrupt_sig <= '1';
        pGen_sig <= '1';
        enable_generate_sig <= '1';
        wait for clk_period*2;
        
        pInterrupt_sig <= '0';
        wait for clk_period*48;
        
        pGen_sig <= '0';
        eGen_sig <= '0';
        enable_generate_sig <= '0';
        wait for clk_period*10;
        
        -- Generamos el preamble de un ePacket
        eGen_sig <= '1';
        enable_generate_sig <= '1';
        wait for clk_period*50;
        
        pGen_sig <= '0';
        eGen_sig <= '0';
        enable_generate_sig <= '0'; 
        wait for clk_period*10;
        
        -- Generamos el preamble de un frag. pPacket (no primer frag.)
        pInterrupt_sig <= '1';
        pGen_sig <= '1';
        enable_generate_sig <= '1';
        wait for clk_period*2;
                
        pInterrupt_sig <= '0';
        wait for clk_period*48;
        
        pGen_sig <= '0';
        eGen_sig <= '0';
        enable_generate_sig <= '0';
        wait for clk_period;
    
      wait;
    end process;

end Behavioral;
