----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 09.06.2019 17:02:00
-- Design Name: 
-- Module Name: testbench_select_generated_data - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity testbench_select_generated_data is
--  Port ( );
end testbench_select_generated_data;

architecture Behavioral of testbench_select_generated_data is

    component select_generated_data is
    Port (  clk : in STD_LOGIC;
            preamble : in STD_LOGIC_VECTOR (7 downto 0);
            payload : in STD_LOGIC_VECTOR (7 downto 0);
            fsc : in STD_LOGIC_VECTOR (7 downto 0);
            sel : in STD_LOGIC_VECTOR (0 to 3);
            data : out STD_LOGIC_VECTOR (7 downto 0));
    end component;
    
    --Inputs
    signal clk_sig :        STD_LOGIC                     := '0';
    signal preamble_sig :   STD_LOGIC_VECTOR (7 downto 0) := "00000000";
    signal payload_sig :    STD_LOGIC_VECTOR (7 downto 0) := "00000000";
    signal fsc_sig :        STD_LOGIC_VECTOR (7 downto 0) := "00000000";
    signal sel_sig :        STD_LOGIC_VECTOR (0 to 3)     := "0000"; 
    
    --Outputs
    signal data_sig :       STD_LOGIC_VECTOR (7 downto 0) := "00000000";
    
    --Clock period definition
    constant clk_period : time := 20 ns; --Seal de 50Mhz
       
begin
    -- Instantiate the Unit Under Test (UUT)
    UUT: select_generated_data PORT MAP (
          clk => clk_sig,
          preamble => preamble_sig,
          payload => payload_sig,
          fsc => fsc_sig,
          sel => sel_sig,
          data => data_sig
          );
    
    -- Clock process definitions
    clk_process :process
    begin
        clk_sig <= '0';
        wait for clk_period/2;
        clk_sig <= '1';
        wait for clk_period/2;
    end process;
    
    -- Stimulus process
    stim_proc: process
    begin        
      -- hold reset state for 100 ns.
        preamble_sig <= "10101010";
        payload_sig <= "11111111";
        fsc_sig <= "00001111";
        sel_sig <= "0000";
        wait for clk_period*2;
        
        -- Seleccionamos Preamble
        sel_sig <= "1000";
        wait for clk_period*2;     
        -- Seleccionamos Payload
        sel_sig <= "0100";
        wait for clk_period*2;
        -- Seleccionamos Fsc
        sel_sig <= "0010";
        wait for clk_period*2;
        -- Seleccionamos Gap
        sel_sig <= "0001";
        wait for clk_period*2;
        -- Seleccionamos Nada
        sel_sig <= "0000";
        wait for clk_period*2;
    
      wait;
    end process;

end Behavioral;
