----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 09.06.2019 17:00:37
-- Design Name: 
-- Module Name: testbench_select_generating_block - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity testbench_select_generating_block is
--  Port ( );
end testbench_select_generating_block;

architecture Behavioral of testbench_select_generating_block is

   component select_generating_block is
    Port ( clk : in STD_LOGIC;
           rst : in STD_LOGIC;
           mGen : in STD_LOGIC;
           endBlock : in STD_LOGIC_VECTOR (0 to 4);
           header_gen : out STD_LOGIC;
           data_gen : out STD_LOGIC;
           selBlock : out STD_LOGIC_VECTOR (0 to 3));
    end component;
   
   --Inputs
   signal clk_sig :  STD_LOGIC := '0';
   signal rst_sig :  STD_LOGIC := '0';
   signal mGen_sig :  STD_LOGIC := '0';
   signal endBlock_sig : STD_LOGIC_VECTOR (0 to 4) := "00000";
   
   --Outputs
   signal header_gen_sig :  STD_LOGIC := '0';
   signal data_gen_sig :  STD_LOGIC := '0';
   signal selBlock_sig : STD_LOGIC_VECTOR (0 to 3) := "0000";
   
   --Clock period definition
   constant clk_period : time := 20 ns; --Seal de 50Mhz
   
begin
    -- Instantiate the Unit Under Test (UUT)
    UUT: select_generating_block PORT MAP (
          clk => clk_sig,
          rst => rst_sig,
          mGen => mGen_sig,
          endBlock => endBlock_sig,
          header_gen => header_gen_sig,
          data_gen => data_gen_sig,
          selBlock => selBlock_sig
          );
    
    -- Clock process definitions
    clk_process :process
    begin
        clk_sig <= '0';
        wait for clk_period/2;
        clk_sig <= '1';
        wait for clk_period/2;
    end process;
    
    -- Stimulus process
    stim_proc: process
    begin        
      -- hold reset state for 100 ns.
        rst_sig <= '1';
        wait for clk_period*2;
        
        rst_sig <= '0';
        wait for clk_period*2;
        
        --Comienza generacion de trama
        mGen_sig <= '1';
        wait for clk_period*8;
        
        --Fin de preamble
        endBlock_sig <= "10000";
        wait for clk_period*8;
        
        --Fin de cabecera Payload
        endBlock_sig <= "01000";
        wait for clk_period*12;
        
        --Fin de datos Payload
        endBlock_sig <= "01100";
        wait for clk_period*48;
        
        --Fin de Fsc
        endBlock_sig <= "00010";
        wait for clk_period*4;
        
        --Fin
        
    
      wait;
    end process;

end Behavioral;
