----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 22.05.2019 18:13:56
-- Design Name: 
-- Module Name: testbench_payload_data_generator - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity testbench_payload_data_generator is
--  Port ( );
end testbench_payload_data_generator;

architecture Behavioral of testbench_payload_data_generator is

    component payload_data_generator 
    Port ( clk : in STD_LOGIC;
           enable_generate : in STD_LOGIC;
           mData : in STD_LOGIC_VECTOR (7 downto 0);
           mLast : in STD_LOGIC;
           payload : out STD_LOGIC_VECTOR (7 downto 0);
           ended_header : out STD_LOGIC;
           ended_data : out STD_LOGIC);
    end component;
    
    --Inputs
    signal clk_sig :  STD_LOGIC := '0';
    signal enable_generate_sig :  STD_LOGIC := '0';
    signal mData_sig :  STD_LOGIC_VECTOR(7 downto 0) := "00000000";
    signal mLast_sig : STD_LOGIC:= '0';
    
    --Outputs
    signal payload_sig : STD_LOGIC_VECTOR (7 downto 0) := "00000000";
    signal ended_header_sig :  STD_LOGIC := '0';
    signal ended_data_sig :  STD_LOGIC := '0';
    
    --Clock period definition
    constant clk_period : time := 20 ns; --Seal de 50Mhz
       
begin
    -- Instantiate the Unit Under Test (UUT)
    UUT: payload_data_generator PORT MAP (
          clk => clk_sig,
          enable_generate => enable_generate_sig,
          mData => mData_sig,
          mLaST => mLaST_sig,
          payload => payload_sig,
          ended_header => ended_header_sig,
          ended_data => ended_data_sig
          );
    
    -- Clock process definitions
    clk_process :process
    begin
        clk_sig <= '0';
        wait for clk_period/2;
        clk_sig <= '1';
        wait for clk_period/2;
    end process;
    
    -- Stimulus process
    stim_proc: process
    begin        
      -- hold reset state for 100 ns.
        mData_sig <= "10101010";
        mLast_sig <= '0';
        enable_generate_sig <= '0';
        wait for clk_period*2;
        
        -- Generamos payload durante varios ciclos de reloj, hasta que se indique fin
        enable_generate_sig <= '1';
        wait for clk_period*60;
        
        mLast_sig <= '1';
        wait for clk_period*4;
       
        enable_generate_sig <= '0';
        wait for clk_period*10;
    
      wait;
    end process;

end Behavioral;
